﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.ServiceModel;
using System.ServiceModel.Activation;
using System.ServiceModel.Web;
using WcfRestServiceDemo.Data;

namespace WcfRestServiceDemo.Service
{
    [ServiceContract(Namespace = "WcfRestServiceDemo")]
    [AspNetCompatibilityRequirements(RequirementsMode = AspNetCompatibilityRequirementsMode.Allowed)]
    [ServiceBehavior(InstanceContextMode = InstanceContextMode.PerCall)]
    public class MicroblogService
    {
        [WebGet(UriTemplate = "")]
        public List<Microblog> GetCollection()
        {
            return WcfRestServiceDemoContainer.Go(container =>
                container.Microblogs.ToList());
        }

        [WebInvoke(UriTemplate = "", Method = "POST")]
        public Microblog Create(Microblog microblog)
        {
            microblog.PublishTime = DateTime.Now;
            WcfRestServiceDemoContainer.GoAndSave(container =>
                container.Microblogs.AddObject(microblog));
            return microblog;
        }

        [WebGet(UriTemplate = "{id}")]
        public Microblog Get(string id)
        {
            return WcfRestServiceDemoContainer.Go(container =>
                container.Microblogs.FirstOrDefault(m => m.Id == int.Parse(id)));
        }

        [WebInvoke(UriTemplate = "{id}", Method = "DELETE")]
        public void Delete(string id)
        {
            WcfRestServiceDemoContainer.GoAndSave(container =>
                container.Microblogs.DeleteObject(
                    container.Microblogs.First(m => m.Id == int.Parse(id))));
        }
    }
}